<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
  <button (click)="getDataSource()" class="btn btn-default">
    <i class="fas fa-sync-alt" [ngClass]="{'fa-spin': !dataGrid}"></i>
  </button>
  <button (click)="newRow(modalHelp)" class="btn btn-primary ml-1">
    <i class="fa fa-plus mr-2"></i>Nuevo
  </button>
  <!-- <button (click)="printPDF()" class="btn btn-danger ml-1" [disabled]="!dataGrid.data">
    <i class="far fa-file-pdf mr-2"></i>PDF
  </button> -->
</app-page-title>


<div class="card">
  <div class="card-body" *ngIf="!loading">

    <kendo-grid [kendoGridBinding]="dataGrid" [filter]="filter" filterable="menu" [selectable]="true" [navigable]="true"
      [reorderable]="true" [resizable]="true" [sortable]="true" (edit)="editRow($event, modalHelp)"
      (remove)="deleteRow($event)" style="height: 69vh">
      <div *ngFor="let item of gridFields">
        <kendo-grid-column [field]="item.dataKey" [title]="item.title" [width]="item.width" [filterable]="item.filtro">
        </kendo-grid-column>
      </div>
      <kendo-grid-column field="sdefault" title="Default" width="120">
        <ng-template kendoGridCellTemplate let-dataItem>
          {{dataItem.sdefault ? 'Si' : 'No'}}
          <!-- <input type="checkbox" [checked]="dataItem.sdefault" disabled/> -->
        </ng-template>
      </kendo-grid-column>
      <kendo-grid-column field="Inactivo" title="Inactivo" width="120">
        <ng-template kendoGridCellTemplate let-dataItem>
          <input type="checkbox" [checked]="dataItem.Inactivo" disabled/>
        </ng-template>
      </kendo-grid-column>
      <kendo-grid-command-column title="Acciones" width="190">
        <ng-template kendoGridCellTemplate let-isNew="isNew">
          <button kendoGridEditCommand [primary]="true">Editar</button>
          <button kendoGridRemoveCommand>Eliminar</button>
        </ng-template>
      </kendo-grid-command-column>
    </kendo-grid>

  </div>
  <app-loading *ngIf="loading"></app-loading>
</div>

<ng-template #modalHelp let-modal let-c="close">
  <div class="modal-header">
    <h6 class="modal-title" id="modal-graf">
      <span *ngIf="flagEdit">Editar Semáforo</span>
      <span *ngIf="!flagEdit">Nuevo Semáforo</span>
    </h6>
    <button class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">

    <form [formGroup]="myFormGroup">
      <div class="row">
        <div class="form-group col-12 col-sm-12 col-md-12 col-lg-12 col-xl-12">
          <label>Semáforo</label>
          <input type="text" class="form-control" formControlName="Semaforo" [readOnly]="flagEdit"
          maxlength="10" pattern="[a-zA-Z0-9]*">
        </div>
        <div class="form-group col-12 col-sm-12 col-md-12 col-lg-12 col-xl-12">
          <label>Descripción</label>
          <input type="text" class="form-control" formControlName="Descripcion" maxlength="40"
          pattern="[a-zA-Z0-9 ]*">
        </div>
        <div class="form-group col-12 col-sm-12 col-md-12 col-lg-12 col-xl-12">
          <label>Color <span [ngStyle]="{'background': colour}" class="template"></span></label>
          <kendo-combobox [data]="semaColor" [textField]="'idColor'" [valueField]="'color'" [filterable]="true"
            [valuePrimitive]="true" formControlName="cColor" (selectionChange)="valueColor($event)"
            class="form-control">
            <ng-template kendoComboBoxItemTemplate let-dataItem>
              <span [ngStyle]="{'background': dataItem.color}" class="template"></span>
              &nbsp; {{ dataItem.idColor }}
            </ng-template>
          </kendo-combobox>
        </div>
      </div>
      <div class="row ">
        <div class="form-group col-6 col-sm-6 col-md-6 col-lg-6">
          <label class="w-100">Default</label>
          <kendo-switch formControlName="sdefault" [onLabel]="'Si'" [offLabel]="'No'"></kendo-switch>
        </div>
        <div class="form-group col-6 col-sm-6 col-md-6 col-lg-6">
          <label class="w-100">Inactivo</label>
          <kendo-switch formControlName="Inactivo" [onLabel]="'Si'" [offLabel]="'No'">
          </kendo-switch>
        </div>
      </div>
    </form>

  </div>
  <div class="modal-footer">
    <button class="btn btn-success mr-1" [disabled]="myFormGroup.invalid" (click)="guardarForm()">
      <i class="fas fa-save mr-2"></i>Guardar
    </button>
    <button class="btn btn-secondary" (click)="c('Close click')">Cerrar</button>
  </div>
</ng-template>
